
<template>
  <div>
    <Modal v-if="displayModal">
      <div id="confirmPannel" class="panel">
        <h2 style="margin-top: 0">{{ title }}</h2>
        <div>{{ message }}</div>
        <div class="btns">
          <button class="cancel-btn red" @click="cancel" v-if="cancelButton">
            {{ cancelButton }}
          </button>
          <button class="ok-btn green" @click="confirm" v-if="okButton">
            {{ okButton }}
          </button>
        </div>
      </div>
    </Modal>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue } from "vue-property-decorator";
// Import components
import Modal from "../common/Modal.vue";

interface confirmParams {
  title?: string;
  message?: string;
  okButton?: string;
  cancelButton?: string;
}

@Component({ components: { Modal } })
export default class ModalConfirm extends Vue {
  //   @Prop({ default: "" }) title!: string;
  //   @Prop({ default: "Cancel" }) cancelBtnText!: string;
  //   @Prop({ default: "Submit" }) submitBtnText!: string;
  displayModal = false;

  // Dialogue parameters
  title?: string;
  message?: string;
  okButton?: string;
  cancelButton? = "Cancel";

  private resolvePromise?: (value: boolean | PromiseLike<boolean>) => void;
  private rejectPromise?: (value: boolean | PromiseLike<boolean>) => void;

  public show(opts: confirmParams = {}): Promise<boolean> {
    this.title = opts.title;
    this.message = opts.message;
    this.okButton = opts.okButton;

    if (opts.cancelButton !== undefined) {
      this.cancelButton = opts.cancelButton;
    }

    this.displayModal = true;

    // Return promise so the caller can get the results
    return new Promise((resolve, reject) => {
      this.resolvePromise = resolve;
      this.rejectPromise = reject;
    });
  }

  private confirm(): void {
    this.displayModal = false;
    if (this.resolvePromise) this.resolvePromise(true);
  }

  private cancel(): void {
    this.displayModal = false;
    if (this.resolvePromise) this.resolvePromise(false);
  }
}
</script>

<style scoped>
#confirmPannel {
  display: flex;
  flex-direction: column;
  gap: 10px;
  min-width: 350px;
}
.btns {
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
  gap: 20px;
}
</style>
